<?php
// $Id$
/**
 * @file
 * Adds pages for character sheet, moved here to save on code footprint.
 */

/*
 * Menu callback, view own character sheets.
 */
function _character_sheet_view_own_sheets() {
  global $user;
  return _character_sheet_view_sheets(' AND n.uid = %d', array($user->uid));
}

/*
 * Menu callback, view all character sheets (same as moderate).
 */
function _character_sheet_view_sheets($modify_sql = '', $modify_vars = array()) {
  if (!empty($modify_sql)) {
    $where_clause = $modify_sql;
    $variables = $modify_vars;
  }
  $labels = array(
    array('data' => t('Character'), 'field' => 'title', 'sort' => 'desc'),
    array('data' => t('Player'), 'field' => 'name', 'sort' => 'desc'),
    array('data' => t('System'), 'field' => 'type', 'sort' => 'desc'),
    //array('data' => t('Game'), 'field' => 'game', 'sort' => 'desc'),
    array('data' => t('Last Updated'), 'field' => 'changed', 'sort' => 'desc'),
    array('data' => t('Status')),
  );
  $character_sheet_types = variable_get('character_sheet_types', array());
  $active_types = array();
  foreach ($character_sheet_types as $type => $status) {
    if ($status) {
      $active_types[] = $type;
    }
  }
  $active_types = "'" . implode("',", $active_types) . "'";
  $query = "SELECT
    n.nid, n.vid, n.title, n.changed, n.type, n.uid, u.name 
    FROM {node} n
    LEFT JOIN {users} u ON n.uid = u.uid
    WHERE n.type IN (" . $active_types . ") " . $where_clause;
  $query .= tablesort_sql($labels);
  $results = pager_query($query, 10, 0, NULL, $variables);
  while ($result = db_fetch_array($results)) {
    $account->uid = $result['uid'];
    $account->name = $result['name'];
    $system = variable_get('character_sheet_system_'. $result['type'], '');
    if (empty($system)) {
      $system = 'no system';
    }
    // node_load is costly, especially within a loop.
    // Thankfully status is the one field we can be sure exists. 
    // So we're going to instead just grab the status directly from the table.
    // The table is guaranteed to exist under a normal installation situation.
    $sheet_status = _character_sheet_get_node_status($result['type'], $result['nid'], $result['vid']);
    // In order to moderate a sheet you must look at it directly. No easy management system 
    $data_set = array(
      'title' => l($result['title'], 'node/' . $result['nid']) . ' ' . theme('mark', node_mark($result['nid'], $result['changed'])),
      'name' => theme('username', $account),
      'type' => $system,
      //'game' => $game_link,
      'changed' => format_date($result['changed']),
      'status' => $sheet_status,
    );
    $data[] = $data_set;
  }
  $output = theme('table', $labels, $data); 
  $output .= theme('pager', NULL, 10, 0);
  return $output;
}
